#include <fstream>
#include <cmath>
#include <cstring>
#include "trimesh.h"
#include "iomesh.h"

bool format_is_variable(const char *fmt);

int main(int argc, char **argv)
{
   if(argc!=3){
      std::cerr<<"usage: obj_to_rib <obj_filename_format> <rib_filename_format>"<<std::endl;
      std::exit(1);
   }

   const char *obj_file_format=argv[1];
   const char *rib_file_format=argv[2];

   TriMesh mesh;
   std::vector<Vec3f> x, normal;

   if(format_is_variable(obj_file_format)){
      for(int frame=0; read_objfile(mesh, x, normal, obj_file_format, frame); ++frame){
	 std::cout<<"Read frame "<<frame<<std::endl;
	 write_ribfile(mesh, x, normal, rib_file_format, frame);
      }
   }else{
      if(read_objfile(mesh, x, normal, obj_file_format)){
	 write_ribfile(mesh, x, normal, rib_file_format);
      }
   }

   return 0;
}

//====================================================================================================

bool format_is_variable(const char *fmt)
{
   for(int c=0; fmt[c]!=0; ++c){
      if(fmt[c]=='%' && fmt[c+1]!='%')
	 return true;
   }
   return false;
}

