#ifndef UTIL_H
#define UTIL_H

#include <algorithm>
#include <vector>

using std::min;
using std::max;

template<class T>
inline T sqr(const T &x)
{ return x*x; }

template<class T>
inline T min(T a1, T a2, T a3)
{ return min(a1, min(a2, a3)); }

template<class T>
inline T min(T a1, T a2, T a3, T a4)
{ return min(min(a1, a2), min(a3, a4)); }

template<class T>
inline T max(T a1, T a2, T a3)
{ return max(a1, max(a2, a3)); }

template<class T>
inline T max(T a1, T a2, T a3, T a4)
{ return max(max(a1, a2), max(a3, a4)); }

template<class T>
inline void minmax(T a1, T a2, T a3, T &amin, T &amax)
{
   if(a1<a2){
      if(a1<a3){
         amin=a1;
         if(a2<a3) amax=a3;
	 else amax=a2;
      }else{
	 amin=a3;
	 if(a1<a2) amax=a2;
	 else amax=a1;
      }
   }else{
      if(a2<a3){
         amin=a2;
         if(a1<a3) amax=a3;
	 else amax=a1;
      }else{
	 amin=a3;
	 amax=a1;
      }
   }
}

template<class T>
inline T clamp(T a, T lower, T upper)
{
   if(a<lower) return lower;
   else if(a>upper) return upper;
   else return a;
}

template<class T>
void zero(std::vector<T> &v)
{ for(int i=v.size()-1; i>=0; --i) v[i]=0; }

template<class T>
void add_unique(std::vector<T> &a, T e)
{
   for(unsigned int i=0; i<a.size(); ++i)
      if(a[i]==e) return;
   a.push_back(e);
}

#endif

