#include "hashgrid.h"

void HashGrid3D::
add_box(const Vec3f &xmin, const Vec3f &xmax, int index)
{
   Vec3i imin=round(xmin*overdx), imax=round(xmax*overdx);
   for(int k=imin[2]; k<=imax[2]; ++k) for(int j=imin[1]; j<=imax[1]; ++j) for(int i=imin[0]; i<=imax[0]; ++i)
      grid.add(Vec3i(i,j,k), index);
}

void HashGrid3D::
delete_box(const Vec3f &xmin, const Vec3f &xmax, int index)
{
   Vec3i imin=round(xmin*overdx), imax=round(xmax*overdx);
   for(int k=imin[2]; k<=imax[2]; ++k) for(int j=imin[1]; j<=imax[1]; ++j) for(int i=imin[0]; i<=imax[0]; ++i)
      grid.delete_entry(Vec3i(i,j,k), index);
}

bool HashGrid3D::
find_point(const Vec3f &x, std::vector<int> &index_list) const
{
   index_list.clear();
   for(HashTable<Vec3i,int>::list_iterator lister=grid.begin_list(round(x*overdx)); lister.still_going(); ++lister)
      index_list.push_back(lister->data);
   return index_list.size()>0;
}

bool HashGrid3D::
find_box(const Vec3f &xmin, const Vec3f &xmax, std::vector<int> &index_list) const
{
   index_list.clear();
   Vec3i imin=round(xmin*overdx), imax=round(xmax*overdx);
   for(int k=imin[2]; k<=imax[2]; ++k) for(int j=imin[1]; j<=imax[1]; ++j) for(int i=imin[0]; i<=imax[0]; ++i)
      for(HashTable<Vec3i,int>::list_iterator lister=grid.begin_list(Vec3i(i,j,k)); lister.still_going(); ++lister)
         index_list.push_back(lister->data);
   return index_list.size()>0;
}

