#ifdef __APPLE__
#include <OpenGL/gl.h> // why does Apple have to be different???
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#include <GL/glut.h>
#endif
#include "display.h"

void display_mesh(const TriMesh &mesh, const std::vector<Vec3f> &x, const std::vector<Vec3f> &normal)
{
   int i, j, k;
   if(normal.empty()){
      glPushAttrib(GL_NORMALIZE);
      glEnable(GL_NORMALIZE);
      glBegin(GL_TRIANGLES);
      for(unsigned int t=0; t<mesh.tri.size(); ++t){
         assign(mesh.tri[t], i, j, k);
         glNormal3fv(cross(x[i]-x[j], x[i]-x[k]).v);
         glVertex3fv(x[i].v);
         glVertex3fv(x[j].v);
         glVertex3fv(x[k].v);
      }
      glEnd();
      glPopAttrib();
   }else{
      glBegin(GL_TRIANGLES);
      for(unsigned int t=0; t<mesh.tri.size(); ++t){
         assign(mesh.tri[t], i, j, k);
         glNormal3fv(normal[i].v);
         glVertex3fv(x[i].v);
         glNormal3fv(normal[j].v);
         glVertex3fv(x[j].v);
         glNormal3fv(normal[k].v);
         glVertex3fv(x[k].v);
      }
      glEnd();
   }
}

